#Oct 28,2012:Update:Bugfix about MWALL and SHAPES and AXIS inference.
#Dec 04,2012.Update:Bug fix.about Drawing in group.
#Feb 19,2013:modified.
require 'sketchup.rb'
require 't2h_building_structure_tool/tst1_mod_create_geometry.rb'
require 't2h_building_structure_tool/tst1_mod_common_util.rb'
require 't2h_building_structure_tool/tst1_mod_bst_propery_man_dummy.rb'

require 't2h_building_structure_tool/tst1_mod_extend_to_structure.rb'
require 't2h_building_structure_tool/tst1_mod_chamfer.rb'
require 't2h_building_structure_tool/tst1_mod_extend_to_face.rb'
require 't2h_building_structure_tool/tst1_mod_click_two_bst_entity.rb'
require 't2h_building_structure_tool/tst1_mod_grow_to_face.rb'
require 't2h_building_structure_tool/tst1_mod_grow_to_structure.rb'
module TAK2HATA::T2H_BuildingStrcutureTool
class TST1_class_extend_str
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_extend_structures
end
class TST1_class_chamfer
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_chamfer
end
class TST1_class_extend_face
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_extend_to_face
end
class TST1_class_grow_face
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_grow_to_face
end
class TST1_class_grow_str
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_grow_to_str
end
class TST1_class_tool_for_wdlg_main
		include TST1_mod_create_geometry
		include TST1_mod_chamfer
		include TST1_mod_common_util
		def show_states_text()
			if @beams_props["bclass"] == "SLAB"
				if @slabstate == 1
					Sketchup::set_status_text langconv( "Click point to Hit Slab Level:[Esc]=Quit" )
				elsif @slabstate == 2
					Sketchup::set_status_text langconv( "Click point to Create Slab Level:[Esc]=Quit" )
				else
					Sketchup::set_status_text langconv( "Click point to Hit Area.:[Esc]=Quit" )
				end
			else
				if @state == 0
					Sketchup::set_status_text langconv( "First point:[Esc]=Quit" )
				else
					Sketchup::set_status_text langconv("Next point:[Esc]=Quit")
				end
			end
		end
		def initialize( btdlg , slabstate = 0)
			$bst_tool_wdlg = btdlg
			get_All_Properties( $bst_tool_wdlg )
			@pwall = nil
			@first_point = nil
			@first_wall = nil
			@slabstate = slabstate.to_i
			@state = 0
			##$bst_parts_units = "mm"
			#Sketchup.active_model.layers.add "Structure-#{@bclass}"
		end
		def activate
			@ip  = Sketchup::InputPoint.new
			@ip1 = Sketchup::InputPoint.new
			@ip2 = Sketchup::InputPoint.new
			Sketchup.active_model.active_view.lock_inference
			self.reset(nil)
			@drawn = false
			show_states_text()
			Sketchup::set_status_text "", SB_VCB_VALUE
        end
        def reset(view)
            @pts              = []
            @shape_pts         = []
            @state            = 0
            @drawn            = false
            @ip.clear
            @ip1.clear
            @ip2.clear
			show_states_text()
            view.lock_inference if view
        end
        def reset2(view)
			pt = @pts[1]
			if view
                if( view.inference_locked? )
					trrot = Geom::Transformation.rotation( pt3d( 0,0,0 ) , vec3d( 0,0,1 ) , 90.degrees )
					vec = pt.vector_to( @pts[0] ).transform( trrot )
					trvec = Geom::Transformation.translation( vec )
					pt2 = pt.transform( trvec )
                    view.lock_inference Sketchup::InputPoint.new( pt2 ) , Sketchup::InputPoint.new( pt )
                end
                view.invalidate
			end
			@ip1 = Sketchup::InputPoint.new( pt )
            @pts = []
			@pts.push pt
            @shape_pts         = []
            @state            = 1
            @drawn            = false
            @ip.clear
            @ip2.clear
            show_states_text()
        end
        def resume(view)
            show_states_text()
        end
        def deactivate(view)
            view.invalidate if @drawn
        end

        def onCancel(flag, view)
            # Clean view and exit the tool
            view.invalidate if @drawn
			if ( @beams_props["bclass"] == "RC_WALL" or @beams_props["bclass"] == "MWALL" ) and @state == 1
				@pgeom = nil
				self.reset(view)
			else
				Sketchup.active_model.select_tool nil
			end
        end

        def onReturn(view)
            # Clean view and exit the tool
            view.invalidate if @drawn
            self.reset(view)
            Sketchup.active_model.select_tool nil
		end
		
        def drawBeam(view)
			#get_All_Properties( $bst_tool_wdlg )
			start_operation( "draw structure")
			pgeom = self.create_geometry2( @pts , @pgeom )
			Sketchup.active_model.commit_operation
			@pgeom = pgeom
			if @beams_props["bclass"] == "RC_WALL" or @beams_props["bclass"] == "MWALL"
				self.reset2(view)
			else
				self.reset(view)
			end
		end

        def onRButtonDown(flags, x, y, view)
            dialog()
            view.invalidate
			#onReturn(view)
        end

        def onUserText(text, view)
            ##if @state == 0
                # enter hariHugo
                #dialog text
            ##end
			
            return if not @state == 1
            return if not @ip2.valid?

                begin
                    value = text.to_l
                rescue
                    # Error parsing the text
                    UI.messagebox( "#{text} " + langconv( "cannot convert to a Length" ) )
                    value = nil
                    Sketchup::set_status_text "", SB_VCB_VALUE
                end
            return if !value
			#end
            # Compute the direction and the second point
            if ( @state == 1 )            
	            #pt1 = @ip1.position
				pt2 = @ip2.position
				pt2.z = @beams_props["beams_fixz"] if ["true","Yes"].include?(@beams_props["beams_fixz_chk"].to_s)
				vec = @pts[0].vector_to(pt2)
                if vec.length == 0.0
	                UI.messagebox( langconv("Zero length invalid !") )
	                return
	            end
	            vec.length = value
	            pt2 = @pts[0] + vec
	            # Store point
	            @pts.push(pt2)

            	#@ip1 = Sketchup::InputPoint.new( @pts[1] )
				drawBeam( view )
            end
            view.invalidate
        end

        def onMouseMove(flags, x, y, view)
            if( @state == 0 )
                show_states_text()
                # Getting the first end
                @ip.pick view, x, y
                if( @ip != @ip1 )
                    # if the point has changed from the last one we got
                    view.invalidate if( @ip.display? or @ip1.display? )
                    @ip1.copy! @ip
                    # set the tooltip that should be displayed to this point
                    view.tooltip = @ip1.tooltip
                end
            else
                # Getting the next end
				show_states_text()
                Sketchup::set_status_text langconv("LENGTH"), SB_VCB_LABEL
                @ip2.pick view, x, y, @ip1

                # Update the length displayed in the VCB
                if( @ip2.valid? )
                    length = @ip1.position.distance(@ip2.position)
                    Sketchup::set_status_text length.to_s, SB_VCB_VALUE
                end

                view.tooltip = @ip2.tooltip if( @ip2.valid? )
                view.invalidate
            end
        end
        def onLButtonDown(flags, x, y, view)
			#get_All_Properties( $bst_tool_wdlg )
if ( @state == 0 )
	if( @ip1.valid? )
		@pts.push(@ip1.position)
		fc1 = @ip1.face
		apath = Sketchup.active_model.active_path
		exist_entity = false
		if fc1
			if is_kind( fc1.parent ,"Model")
			elsif apath != nil and fc1.parent.group?
				fc1.parent.instances.each{|igrp|
					if fc1.parent.entityID == apath[apath.size-1].entityID
						exist_entity = false
						break
					else
						exist_entity = true
					end
				}
			end
		end
		if @beams_props["bclass"] == "SLAB"
			if @slabstate == 1
				slab_toplevel = @beams_props["slab_toplevel"] = @ip1.position.z
				$bst_tool_wdlg.execute_script(%Q{set_text("BST_GENLEVEL","#{esc_html_seq(slab_toplevel)}")})
				#@slabstate = 0
			elsif @slabstate == 2
				slab_hitlevel = @beams_props["slab_hitlevel"] = @ip1.position.z
				$bst_tool_wdlg.execute_script(%Q{set_text("BST_CLICKLEVEL","#{esc_html_seq(slab_hitlevel)}")})
				#@slabstate = 0
			else
				get_All_Properties( $bst_tool_wdlg )
				pt = @ip.position.clone
				camera = view.camera
				slab_hitlv = @beams_props["slab_hitlevel"].to_l
				line1 = [ pt , camera.eye ]
				plane1 = [ pt3d( 0,0,slab_hitlv ) ,  vec3d( 0,0,1 ) ]
				intpt = Geom.intersect_line_plane(line1, plane1)
				if intpt == nil
					return
				else
					if camera.eye.distance( intpt ) > camera.eye.distance( pt ) and fc1
						slab_from_face( view , fc1 ,  x, y ) if fc1
					elsif camera.eye.distance( intpt ) == camera.eye.distance( pt ) and exist_entity == true
						p "here exist entity"
					elsif camera.eye.distance( intpt ) == camera.eye.distance( pt ) and fc1
						#実際にクリックした点と仮想平面上のクリック点が同一の場合そこにすでに何かあるということになる。
						#それが作業グループに属する単なる面であればスラブを発生させる
						slab_from_face( view , fc1 ,  x, y )
					else
						p "slab from clicking point"
						dzs = [ 0 , -5.mm , 5.mm ]
						chk = false
						dzs.each{|dz|
							@beams_props["slab_hitlevel"] = slab_hitlv + dz
							plane1 = [ pt3d( 0,0, slab_hitlv + dz ) ,  vec3d( 0,0,1 ) ]
							intpt = Geom.intersect_line_plane(line1, plane1)		
							chk = create_slab_withPT( intpt , plane1 )
							break if chk != false
						}
						if chk == false and fc1
							#作成がうまくいかなかった場合
							slab_from_face( view , fc1 ,  x, y )
						end
						@beams_props["slab_hitlevel"] = slab_hitlv
						reset(view)
					end
				end
			end
		else
			@ip1 = Sketchup::InputPoint.new( @pts[0] )
			get_All_Properties( $bst_tool_wdlg )
			@pts[0].z = @beams_props["beams_fixz"] if ["true","Yes"].include?(@beams_props["beams_fixz_chk"].to_s)
			if @beams_props["bclass"] == "STEEL_COLUMN" or @beams_props["bclass"] == "RC_COLUMN"
				@pts.push( [ @pts[0].x , @pts[0].y , @pts[0].z + @beams_props["beams_height"] ] )
				drawBeam( view )
			elsif @beams_props["bclass"] == "RC_FOOTING"
				@pts.push( [ @pts[0].x , @pts[0].y , @pts[0].z + 1000.mm ] )
				drawBeam( view )
			else
				@state+=1
			end
		end
	end
end
if ( @state == 1 )
                #check next point
                if( @ip2.valid? )
					pt2 = @ip2.position
					pt2.z = @beams_props["beams_fixz"] if ["true","Yes"].include?(@beams_props["beams_fixz_chk"].to_s)
                    if @pts[0].vector_to(pt2).normalize.length > 0
						if( @beams_props["bclass"] == "RC_WALL" or @beams_props["bclass"] == "MWALL" ) and @pts[0].vector_to(pt2).parallel?(vec3d( 0,0,1 ))
						else
							@pts.push(pt2)
							drawBeam( view )
						end
					end
                end
end
            view.invalidate
        end
        def slab_from_face( view , fc1 , x , y )
			ifc = fc1
			ph = view.pick_helper
			ph.do_pick x,y
			pe = ph.best_picked
			camera = view.camera
			if pe and pe.entityID == ifc.entityID
				p "slab from face"
				createSlabFromFace( ifc )
				reset(view)
			else
				reset(view)
				return
			end
		end
        # Draw temp line between ends of partition axis
        def draw_temp_line(pt1, pt2, view)
            #view.drawing_color = "red"
            view.set_color_from_line(pt1, pt2)
            #view.line_stipple="-.-"
            if view.inference_locked?
                view.line_width=2
            end
            #@bbp = [pt1, pt2]
            view.draw_line(pt1, pt2)
        end

        def getExtents
            #bb = Geom::BoundingBox.new
            #bb.aptsdd(pt) if pt
            #if @bbp
			#	@bbp.each { |pt| bb.add(pt) }
            #end
        end

        def onKeyDown(key, rpt, flags, view)
            if( key == CONSTRAIN_MODIFIER_KEY )
                # if we already have an inference lock, then unlock it
                if( view.inference_locked? )
					p "-locked"
                    view.lock_inference
                elsif( @state == 1 )
					p "state1"
                    ##view.lock_inference @ip2, @ip1##110909
                    view.lock_inference @ip2 , @ip1
                else
					p "stateelse"
                    view.lock_inference @ip2
                end
                view.invalidate
            end
        end

        def onKeyUp(key, rpt, flags, view)
            if( key == CONSTRAIN_MODIFIER_KEY && view.inference_locked? )
                #(Time.now - @shift_down_time) > 0.5 )
                view.lock_inference
            end
            if key == 9 # or key == 15 or key == 48 # Tab key (according to TIG) ?
                dialog()
            end
            view.invalidate
        end
		
        def draw(view)
            # Show input points when valid
            if( @ip1.valid? )
                if( @ip1.display? )
                    @ip1.draw(view)
                    #@drawn = true
                end  
                if( @ip2.valid? )
                    @ip2.draw(view) if( @ip2.display? )
                    self.draw_temp_line(@ip1.position, @ip2.position, view) if (@ip1.valid? and @ip2.valid?)
                    #@drawn = true
                end
            end
			if @beams_props["bclass"] == "SLAB"
				slab_toplevel = @beams_props["slab_toplevel"] = $bst_tool_wdlg.get_element_value("BST_GENLEVEL").to_l
				slab_hitlevel = @beams_props["slab_hitlevel"] = $bst_tool_wdlg.get_element_value("BST_CLICKLEVEL").to_l
				previewcolor = ""
				if @slabstate == 1
					previewlevel = @ip1.position.z
					previewcolor = "DarkOliveGreen"
				elsif @slabstate == 2
					previewlevel = @ip1.position.z
					previewcolor = "DarkOrange"
				end
				model = Sketchup.active_model
				slab_pr_pts = []
				bbmin = model.bounds.min
				bbmax = model.bounds.max
				bbx = ( bbmax.x - bbmin.x ) / 20.0
				bby = ( bbmax.y - bbmin.y ) / 20.0
				[slab_hitlevel,slab_toplevel,previewlevel].each{|lv|
					pts = []
					21.times{|t|
						pts.push [ bbx * t.to_f + bbmin.x , bbmin.y , lv ]
						pts.push [ bbx * t.to_f + bbmin.x , bbmax.y , lv ]
						pts.push [ bbmin.x , bby * t.to_f + bbmin.y , lv ]
						pts.push [ bbmax.x , bby * t.to_f + bbmin.y , lv ]
					}
					slab_pr_pts.push pts
				}
				view.drawing_color="DarkOrange"
				view.line_width = 3
				view.draw_lines(slab_pr_pts[0])
				view.drawing_color="DarkOliveGreen"
				view.draw_lines(slab_pr_pts[1])
				if previewcolor != ""
					view.drawing_color=previewcolor
					view.line_width = 1
					view.draw_lines(slab_pr_pts[2])
				end
			end
            # Show the previously drawn axis
            #self.draw_previous_points(view)
            @drawn = true
        end

end
module TST1_class_tool_for_wdlg
		#include TST1_mod_create_geometry
		#include TST1_mod_chamfer
		#include TST1_mod_common_util
		#include TST1_mod_bst_propery_man_dummy
		def read_classdefaults(bclass="STEEL_BEAM")
			beams_props = {}
			beams_props["bclass"] = bclass
			beams_props["wall_width"] = 100.mm
			beams_props["beams_fixz"] = 0
			beams_props["beams_spec"] = ""
			beams_props["beams_top"] = 0.0
			beams_props["beams_height"] = 1000.mm
			beams_props["beams_rot"] = 0.0
			beams_props["beams_mirz"] = "false"
			beams_props["beams_axis"] = "true"
			if beams_props["bclass"] == "STEEL_COLUMN" or beams_props["bclass"] == "RC_COLUMN"
				beams_props["beams_just"]   = "Center"
				beams_props["beams_vjust"]   = "Middle"
			elsif beams_props["bclass"] == "RC_WALL"
				beams_props["beams_just"]   = "Center"
				beams_props["beams_vjust"]   = "Bottom"
			elsif beams_props["bclass"] == "MWALL"
				beams_props["beams_just"]   = "Center"
				beams_props["beams_vjust"]   = "Bottom"
			else
				beams_props["beams_just"]   = "Center"
				beams_props["beams_vjust"]   = "Top"
			end

			if beams_props["bclass"] != "SLAB"
				defaults = Sketchup.read_default("T2H_BST", "#{beams_props["bclass"]}:params")
				if not defaults
					tst_clear_class_default(beams_props["bclass"])
					defaults = Sketchup.read_default("T2H_BST", "#{beams_props["bclass"]}:params")
				end
				if defaults 
					results = eval( defaults )
					beams_props["beams_just"]   = results[0] if results.size > 0
					beams_props["beams_vjust"]   = results[1] if results.size > 1
					beams_props["beams_axis"]   = results[2] if results.size > 2
					beams_props["beams_spec"]   = results[3] if results.size > 3
					beams_props["beams_mirz"] = results[4] if results.size > 4
					beams_props["beams_fixz"] = getNumeric(results[5]).inch if results.size > 5 
					beams_props["beams_top"] = getNumeric(results[6]).inch if results.size > 6
					beams_props["beams_height"] = getNumeric(results[7]).inch if results.size > 7
					beams_props["beams_rot"] = getNumeric( results[8] ) if results.size > 8
					beams_props["wall_width"] = getNumeric(results[9]).inch if results.size > 9
					beams_props["bprofile"] = results[10] if results.size > 10
					beams_props["beams_fixz_chk"] = results[11] if results.size > 11
					beams_props["as_component"] = results[12] if results.size > 12
				
					$bst_tool_wdlg.execute_script("document.getElementById('BST_FIXZ').value='" + beams_props["beams_fixz"].to_s.split("'").join( "' + \"'\" + '") + "'" )
					if ["true","Yes"].include?(beams_props["beams_fixz_chk"].to_s)
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_FIXZ").value="true"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_FIXZ").checked=true')
						
					else
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_FIXZ").value="false"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_FIXZ").checked=false')
						
					end
					if ["true","Yes"].include?(beams_props["beams_axis"])
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_AXIS").value="true"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_AXIS").checked=true')
					else
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_AXIS").value="false"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_AXIS").checked=false')
					end
					if ["true","Yes"].include?(beams_props["beams_mirz"])
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").value="true"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").checked=true')
					else
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").value="false"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").checked=false')
					end
					if ["true","Yes"].include?(beams_props["as_component"])
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_COMP").value="true"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_COMP").checked=true')
					else
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_COMP").value="false"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_COMP").checked=false')
					end
					$bst_tool_wdlg.execute_script( "document.getElementById('BST_HEIGHT').value='#{esc_html_seq(beams_props["beams_height"])}'" )
					$bst_tool_wdlg.execute_script( "document.getElementById('BST_WIDTH').value='#{esc_html_seq(beams_props["wall_width"])}'" )#" + beams_props["wall_width"].to_s.split("'").join( "' + \"'\" + '") + "'" )
					$bst_tool_wdlg.execute_script( "document.getElementById('BST_ROTATE').value='#{esc_html_seq(beams_props["beams_rot"])}'" )#" + beams_props["beams_rot"].to_s.split("'").join( "' + \"'\" + '") + "'" )
					v = 3 if beams_props["beams_just"] == "Left"
					v = 2 if beams_props["beams_just"] == "Center"
					v = 1 if beams_props["beams_just"] == "Right"
					v = v + 3 if beams_props["beams_vjust"] == "Middle"
					v = v + 6 if beams_props["beams_vjust"] == "Top"
					$bst_tool_wdlg.execute_script('document.getElementById("jst' + v.to_s + '").checked=true')
					$bst_tool_wdlg.execute_script('document.getElementById("BST_JUST").value="' + v.to_s + '"')
				end
			else
				sl_defaults = Sketchup.read_default("T2H_BST", "SLAB:params" )
				if not sl_defaults
					tst_clear_class_default("SLAB")
					sl_defaults = Sketchup.read_default("T2H_BST", "SLAB:params")
				end
				if sl_defaults
					sl_results = eval( sl_defaults )
					beams_props["slab_toplevel"] = getNumeric(sl_results[1]).inch if sl_results.size > 1
					beams_props["slab_hitlevel"] = getNumeric(sl_results[2]).inch if sl_results.size > 2
					beams_props["slab_hitrange"] = getNumeric(sl_results[3]).inch if sl_results.size > 3
					beams_props["as_component"] = sl_results[4] if sl_results.size > 4
					$bst_tool_wdlg.execute_script("document.getElementById('BST_GENLEVEL').value='#{esc_html_seq(beams_props["slab_toplevel"])}'" )
					$bst_tool_wdlg.execute_script("document.getElementById('BST_CLICKLEVEL').value='#{esc_html_seq(beams_props["slab_hitlevel"])}'" )
					$bst_tool_wdlg.execute_script("document.getElementById('BST_CLICKRANGE').value='#{esc_html_seq(beams_props["slab_hitrange"])}'" )
				end
			end
		end
		def save_classdefault()
			#bclass = Sketchup.read_default("T2H_BST", "WDLG_CLASS","ALL")
			get_All_Properties( $bst_tool_wdlg )
			results = []
			#beams_props["bclass"] = bclass if bclass != nil
			if @pbclass != "SLAB"
				results[0] = @beams_props["beams_just"]
				results[1] = @beams_props["beams_vjust"]
				results[2] = @beams_props["beams_axis"]
				results[3] = @beams_props["beams_spec"]
				results[4] = @beams_props["beams_mirz"]
				results[5] = @beams_props["beams_fixz"].inch
				results[6] = @beams_props["beams_top"].inch
				results[7] = @beams_props["beams_height"].inch
				results[8] = @beams_props["beams_rot"]
				results[9] = @beams_props["wall_width"].inch
				results[10] = @beams_props["bprofile"]
				results[11] = "false"
				results[11] = "true" if ["true","Yes"].include?(@beams_props["beams_fixz_chk"].to_s)
				results[12] = @beams_props["as_component"]
				Sketchup.write_default("T2H_BST", "#{@pbclass}:params", results.inspect.gsub( 34.chr , "'"))

			else
				results[0] = ""
				results[1] = @beams_props["slab_toplevel"].inch
				results[2] = @beams_props["slab_hitlevel"].inch
				results[3] = @beams_props["slab_hitrange"].inch
				#results[4] = @beams_props["bprofile"]
				results[4] = @beams_props["as_component"]
				Sketchup.write_default("T2H_BST", "SLAB:params", results.inspect.gsub( 34.chr , "'"))

			end
		end
		def update_subfolder_list(pdir)
			#サブディレクトリのリストを更新
			addliststr = []
			addliststr.push "var str ='"
			addliststr.push '<select name="BST_SFOLDER" id="BST_SFOLDER" size="1" style="width:140px" onChange ="changedSubFolder(this[this.selectedIndex].value)" >'
			addliststr.push '<option value=".">.</option>'
			srfiles=bst_file_join( pdir,"*")
			Dir::glob( srfiles ).each {|f|
				if File::ftype(f) == "directory"
					dname = esc_html_seq( f.split(File::Separator)[-1] )
					if @psubfolder == dname
						addliststr.push '<option selected value="' + dname + '">' + dname + '</option>'
					else
						addliststr.push '<option value="' + dname + '">' + dname + '</option>'
					end
				end
			}
			addliststr.push '</select>'
			addliststr.push "';"
			addliststr.push 'document.getElementById("BST_SFOLDER_DIV").innerHTML = str;'
			jcmd = addliststr.join("")
			$bst_tool_wdlg.execute_script(jcmd)
		end
		def clear_subfolder_list()
			addliststr = []
			addliststr.push %Q{var str ='}
			addliststr.push %Q{<select name="BST_SFOLDER" id="BST_SFOLDER" size="1" style="width:140px" onChange ="changedSubFolder(this[this.selectedIndex].value)" >}
			addliststr.push %Q{<option value=".">.</option>}
			addliststr.push %Q{</select>}
			addliststr.push %Q{';}
			addliststr.push %Q{document.getElementById("BST_SFOLDER_DIV").innerHTML = str;}
			jcmd = addliststr.join("")
			$bst_tool_wdlg.execute_script(jcmd)
		end
		def read_mwalls(subfolder=".")
			pflist = []
			pdir = basedir = bst_file_join( bst_file_dirname( __FILE__ ),"mwalls" )
			if subfolder != "."
				pdir=bst_file_join( basedir,subfolder)
			end
			if not File.exists?(pdir)
				pdir = basedir
			end

			srfiles = bst_file_join( pdir,"*.skp" )
			Dir::glob( srfiles ).each {|f|
				pflist.push ",#{bst_file_basename(f)},,,,,,,,,".gsub(/\,/,"\t")
			}
			pflist_path = srfiles
			update_subfolder_list(basedir)
			return pflist , pflist_path
		end
		def read_shapes(subfolder=".")
			pflist = []
			basedir = bst_file_join( bst_file_dirname( __FILE__ ),"shapes" )
			if subfolder != "."
				pdir=bst_file_join( basedir,subfolder)
			end
			if not pdir or not File.exists?(pdir)
				pdir = basedir
			end
			srfiles = bst_file_join( pdir,"*.skp" )
			Dir::glob( srfiles ).each {|f|
				pflist.push ",[SHAPE]#{bst_file_basename(f,'.*')},,,,,,,,,".gsub(/\,/,"\t")
			}
			pflist_path = srfiles
			update_subfolder_list(basedir)
			return pflist , pflist_path
		end
		def init_webdialog( bclass = "" , chkword = true , subfolder =".")
			ui = Sketchup.read_default("T2H_BST", "WDLG_UI",true)
			if ui == true
				$bst_tool_wdlg.execute_script("enable_tabs();")
			end
			if @tst_langhash
				jcmd = ""
				@tst_langhash.each{|k,v|
					if v and v != ""
					jcmd = jcmd + %Q{translate_lang("#{k}","#{v}");}
					end
				}
				$bst_tool_wdlg.execute_script(jcmd)
				jcmd="$('#BST_CLASS').empty().append('"
				["ALL","STEEL_GIRDER","STEEL_BEAM","STEEL_COLUMN","RC_GIRDER","RC_BEAM","RC_COLUMN","RC_WALL","MWALL","SHAPES","RC_FOOTING","SLAB"].each{|clsname|
					jcmd = jcmd + %Q{<option value="#{clsname}">#{langconv(clsname)}</option>}
				}
				jcmd = jcmd + "');"
				$bst_tool_wdlg.execute_script(jcmd)
				jcmd = ""
				cnt=0
				["Main","Property","Align","Materials","SLAB","TOOLS"].each{|tabname|
					jcmd = jcmd + %Q{$('#tabs ul:first li:eq(#{cnt}) a').text("#{langconv(tabname)}");}
					cnt += 1
				}
				$bst_tool_wdlg.execute_script(jcmd)
			end

			bclass = Sketchup.read_default("T2H_BST", "WDLG_CLASS","ALL") if bclass == ""
			sword = Sketchup.read_default("T2H_BST", "searchword","")

			if bclass == "ALL" and chkword == true
				prompts = [langconv( "Search Word?(BLANK to ALL)" )]
				defaults = [sword]
				results = UI.inputbox prompts, defaults, langconv( "Start from searching with Words?" )
				if results != nil and results != false
					sword = results[0]
					Sketchup.write_default("T2H_BST", "searchword",sword)
				end
			end
			jcmd = 'selectListbox("BST_CLASS","' + bclass + '")'
			$bst_tool_wdlg.execute_script(jcmd)
			sword = "" if bclass != "ALL" or chkword == false
		#overwrite_bstlist

			if bclass == "MWALL"
				@psubfolder =subfolder
				pflist , pflist_path = read_mwalls(subfolder)
				
			elsif bclass == "SHAPES"
				@psubfolder =subfolder
				pflist , pflist_path = read_shapes(subfolder)
			else
				pflisthash , pflist_path , shlisthash= readProfiles(sword)
				pflist = pflisthash[bclass]
				clear_subfolder_list
				@psubfolder="."
			end
			if shlisthash
				jcmd = ""
				jcmd << %Q{var str ='}
				shlisthash.each{|shclass,shlist|
					shclass2 = shclass
					shclass2 = "HC-" if shclass == "[-"
					jcmd << %Q{<select class="SHAPELIST" id="#{shclass2}SHLIST" size="8" style="width:180px;" onChange="set_bst_profile(this[this.selectedIndex].value)">}
					shlist.each{|shapename| jcmd << %Q{<option value="#{shapename}">#{shapename}</option>} }
					jcmd << %Q{</select>}
				}
				jcmd << %Q{';document.getElementById("DROPLIST").innerHTML = str;}
				$bst_tool_wdlg.execute_script(jcmd)
			end
			#jcmd = 'selectListbox("BST_SFOLDER","' + @psubfolder + '")'
			#$bst_tool_wdlg.execute_script(jcmd)
			pflist.delete("")
			addliststr = []
			addliststr.push "var str ='"
			addliststr.push '<select name="BST_SPECS" id="BST_SPECS" size="8" style="width:350px;" onChange ="changedBstSpecs(this[this.selectedIndex].value); "onDblClick ="startDrawing();">'
			pflist.each{|pf|
				#pfval = pf.split("\t").join("  |  ").gsub(/\"/,"&quot;")
				pfval = esc_html_seq(pf.split("\t").join("  |  "))
				addliststr.push '<option value="' + pfval + '">' + pfval + '</option>'
			}
			addliststr.push '</select>'
			addliststr.push "';"
			addliststr.push 'document.getElementById("BST_SPEC_DIV").innerHTML = str;'
			jcmd = addliststr.join("")
			$bst_tool_wdlg.execute_script(jcmd)

			Sketchup.write_default("T2H_BST", "WDLG_CLASS",bclass)
			read_classdefaults(bclass)
			if pflist != []
				specs = pflist[0].split(/\t/).join("  |  ")
				jcmd = 'selectListbox("BST_SPECS","' + specs + '")'
				$bst_tool_wdlg.execute_script(jcmd)
				set_wdlg_properties( specs )
			end
			@pbclass = bclass
		end
		def set_wdlg_properties( specs )
			jcmd = 'changedBstSpecs("' + specs + '")'
			$bst_tool_wdlg.execute_script(jcmd)
		end
		def get_information()
			sel = Sketchup.active_model.selection
			if sel != []
				ent = sel[0]
				@beams_props = get_entity_bst_info( ent )
				#p get_entity_bst_info( ent )
				specs = [ @beams_props["tag"] , @beams_props["bprofile"] , @beams_props["beams_top"] , @beams_props["solid_mat"] , @beams_props["beams_rot"] , @beams_props["fmat"] , @beams_props["bmat"] , @beams_props["secmat"] ].join("  |  ")
				if @beams_props["bclass"] != "" and @beams_props["bclass"] != $bst_tool_wdlg.get_element_value("BST_CLASS")
					jcmd = 'selectListbox("BST_CLASS","' + @beams_props["bclass"] + '")'
					$bst_tool_wdlg.execute_script(jcmd)
					$bst_tool_wdlg.execute_script('clearAll()')
					init_webdialog( @beams_props["bclass"] , false )
				end
				if ["true","Yes"].include?(@beams_props["beams_axis"].to_s)
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_AXIS").value="true"')
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_AXIS").checked=true')
				else
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_AXIS").value="false"')
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_AXIS").checked=false')
				end
				if @beams_props["beams_mirz"] == "true"
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").value="true"')
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").checked=true')
				else
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").value="false"')
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").checked=false')
				end
				if @beams_props["as_component"] == "true"
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_COMP").value="true"')
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_COMP").checked=true')
				else
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_COMP").value="false"')
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_COMP").checked=false')
				end
				$bst_tool_wdlg.execute_script( "document.getElementById('BST_HEIGHT').value='#{@beams_props["beams_height"].to_s}'")
				$bst_tool_wdlg.execute_script( "document.getElementById('BST_WIDTH').value='#{@beams_props["wall_width"].to_s}'")
				$bst_tool_wdlg.execute_script( "document.getElementById('BST_ROTATE').value='#{@beams_props["beams_rot"].to_s}'")

				v = 3 if @beams_props["beams_just"] == "Left"
				v = 2 if @beams_props["beams_just"] == "Center"
				v = 1 if @beams_props["beams_just"] == "Right"
				v = v + 3 if @beams_props["beams_vjust"] == "Middle"
				v = v + 6 if @beams_props["beams_vjust"] == "Top"
				$bst_tool_wdlg.execute_script('document.getElementById("jst' + v.to_s + '").checked=true')
				$bst_tool_wdlg.execute_script('document.getElementById("BST_JUST").value="' + v.to_s + '"')
				
				jcmd = 'changBySpecStrings("' + specs + '")'
				#p specs
				$bst_tool_wdlg.execute_script(jcmd)
			end
		end
		def applyAllProps()
			get_All_Properties( $bst_tool_wdlg )
			tst_replaceAllProps()
		end
		def apply_one_prop( repCate , repVal )
			get_All_Properties( $bst_tool_wdlg )
			tst_replaceAllProps( repCate , repVal )
		end
		def show_bsttooldialog()
			model = Sketchup.active_model
			if $bst_tool_wdlg
				$bst_tool_wdlg.bring_to_front
				return
			end
			if check_profiles() == false
				show_table_editor()
				return
			end
			prfkeys = { 
				:dialog_title => langconv('BST tool Options'), 
				:scrollable => false, 
				:preferences_key => 'tst_bst_tool_option', 
				:height => 305, 
				:width => 435, 
				:left => 150, 
				:top => 150, 
				:resizable => true, 
				:mac_only_use_nswindow => true
			}
			##Case branch about webdialog html if found in path.
			$bst_tool_wdlg = UI::WebDialog.new( prfkeys)
			###bst_tool_wdlg=UI::WebDialog.new('BST tool Options', false,'tst_bst_tool_option', 305, 435, 150, 150, true);bst_tool_wdlg.show;bst_tool_wdlg.set_position(100,50)
			ui = Sketchup.read_default("T2H_BST", "WDLG_UI",true)

			bst_folder_path = bst_file_dirname( __FILE__ )
			bstwdlg_path = bst_file_join(bst_folder_path,"bst_propery_man.html")

			#もしbst_propery_man_dummy.htmlが存在するならそっちを使用する
			
			if File.exists?(bstwdlg_path)
				p "show webdialog by FILE"
				$bst_tool_wdlg.set_file(bstwdlg_path)
			else
				bsthtml = bst_property_man_dummy()##readtextfile( wdlgpath )
				p "show webdialog by CODE"
				##このコードは実験的に変更しています
				bst_folder_path.gsub!(/\\/,"/")
				bsthtml.gsub!("//BST_FOLDER//",bst_folder_path)
				#if ui == true
				#	bsthtml.gsub!("<!-- tab_ui_change_start -->","<!--")
				#	bsthtml.gsub!("<!-- tab_ui_change_end -->","-->")
				#end
				##変更おわり
				$bst_tool_wdlg.set_html( bsthtml )	##変更箇所
			end
			@pbclass="ALL"
			##end
			$bst_tool_wdlg.set_on_close{
				save_classdefault()
				$bst_tool_wdlg = nil
			}
			$bst_tool_wdlg.add_action_callback("save_default"){|d,prm|
				save_classdefault()
			}
			$bst_tool_wdlg.add_action_callback("getInformation"){|d,prm|
				get_information()
			}
			$bst_tool_wdlg.add_action_callback("apply_one"){|d,prm|
				#cateカテゴリ
				#val値
				ar = prm.split('|||||')
				cate = ar[0]
				val = ar[1]
				apply_one_prop( cate , val )
			}
			$bst_tool_wdlg.add_action_callback("startDrawing"){|d,prm|
				model.select_tool TST1_class_tool_for_wdlg_main.new($bst_tool_wdlg)
			}
			$bst_tool_wdlg.add_action_callback("applyAllProps"){|d,prm|
				applyAllProps()
			}
			$bst_tool_wdlg.add_action_callback("AutoCreateByFaces"){
			}
			$bst_tool_wdlg.add_action_callback("changeProp"){|d,prm|
				#cateカテゴリ
				#val値
				ar = prm.split('|||||')
				cate = ar[0]
				val = ar[1]
				#p cate + " " + val
				if val != ""
					if cate[/.*PROFILE.*/]
						@beams_props["bprofile"] = val
					elsif cate[/.*TAG.*/]
						@beams_props["tag"] = val
					elsif cate[/.*S_MAT.*/]
						@beams_props["solid_mat"] = val
					elsif cate[/.*F_MAT.*/]
						@beams_props["fmat"] = val
					elsif cate[/.*B_MAT.*/]
						@beams_props["bmat"] = val
					elsif cate[/.*SEC_MAT.*/]
						@beams_props["secmat"] = val
					elsif cate[/.*MIRR.*/]
					#p $bst_tool_wdlg.get_element_value("CHK_MIRR")
						@beams_props["beams_mirz"] = $bst_tool_wdlg.get_element_value("CHK_MIRR")
						#if $bst_tool_wdlg.get_element_value("CHK_MIRR") == ""
						#	@beams_props["beams_mirz"] = ""
						#end
					elsif cate[/.*ROTATE.*/]##
						@beams_props["beams_rot"] = val
					elsif cate[/.*FIXZ.*/]##
						if $bst_tool_wdlg.get_element_value("CHK_FIXZ") == ""
							@beams_props["beams_fixz"] = val
						else
							@beams_props["beams_fixz"] = "0"
						end
					elsif cate[/.*HEIGHT.*/]##
						@beams_props["beams_height"] = val
					elsif cate[/.*WIDTH.*/]##
						@beams_props["wall_width"] = val
					elsif cate[/.*FLOOR.*/]##
						@beams_props["beams_top"] = val
					elsif cate[/.*jst.*/]##
						@beams_props["beams_just"] = "Left" if val == "1" or val == "4" or val == "7"
						@beams_props["beams_just"] = "Center" if val == "2" or val == "5" or val == "8"
						@beams_props["beams_just"] = "Right" if val == "3" or val == "6" or val == "9"
						@beams_props["beams_vjust"] = "Top" if val == "7" or val == "8" or val == "9"
						@beams_props["beams_vjust"] = "Middle" if val == "4" or val == "5" or val == "6"
						@beams_props["beams_vjust"] = "Bottom" if val == "1" or val == "2" or val == "3"
					end
					@beams_props["beams_spec"] = '"' + [ @beams_props["tag"],@beams_props["bprofile"],@beams_props["beams_top"],@beams_props["solid_mat"],@beams_props["beams_rot"],@beams_props["fmat"],@beams_props["bmat"],@beams_props["secmat"] ].join('","') + '"'
				end
			}
			$bst_tool_wdlg.add_action_callback("changeBstClass"){|d,prm|
				model.select_tool nil
				init_webdialog( prm )
			}
			$bst_tool_wdlg.add_action_callback("changeSubFolder"){|d,sfolder|
				model.select_tool nil
				init_webdialog( @pbclass , false , sfolder )
			}
			$bst_tool_wdlg.add_action_callback("tool_ex2face"){|d,prm|
				model.select_tool TST1_class_extend_face.new( false )
			}
			$bst_tool_wdlg.add_action_callback("tool_extend"){|d,prm|
				model.select_tool TST1_class_extend_str.new
			}
			$bst_tool_wdlg.add_action_callback("tool_grow"){|d,prm|
				model.select_tool TST1_class_grow_face.new( false )
			}
			$bst_tool_wdlg.add_action_callback("tool_combine"){|d,prm|
				model.select_tool TST1_class_chamfer.new
			}
			$bst_tool_wdlg.add_action_callback("tool_exchange"){|d,prm|
				TST_common.tst_exchange_dialog
			} 
			$bst_tool_wdlg.add_action_callback("tool_ex2face"){|d,prm|
				model.select_tool TST1_class_extend_face.new( false )
			}
			$bst_tool_wdlg.add_action_callback("tool_extend"){|d,prm|
				model.select_tool TST1_class_extend_str.new
			}
			$bst_tool_wdlg.add_action_callback("tool_grow"){|d,prm|
				model.select_tool TST1_class_grow_face.new( false )
			}
			$bst_tool_wdlg.add_action_callback("tool_combine"){|d,prm|
				model.select_tool TST1_class_chamfer.new
			}
			$bst_tool_wdlg.add_action_callback("toggle_ui"){|d,prm|
				ui = Sketchup.read_default("T2H_BST", "WDLG_UI",true)
				if ui == true
					Sketchup.write_default("T2H_BST", "WDLG_UI",false)
				else
					Sketchup.write_default("T2H_BST", "WDLG_UI",true)
				end
				$bst_tool_wdlg.close
				show_bsttooldialog()
			}
			$bst_tool_wdlg.add_action_callback("preview_slab_level"){|d,prm|
				model.active_view.refresh
			}
			$bst_tool_wdlg.add_action_callback("level_click"){|d,prm|
				model.select_tool TST1_class_tool_for_wdlg_main.new($bst_tool_wdlg,prm)
			}
			#bst_wdlg.add_action_callback(""){|d,prm|
			#}
			if RUBY_PLATFORM[/darwin/]
				$bst_tool_wdlg.show_modal { init_webdialog() }
			else
				$bst_tool_wdlg.show { init_webdialog() }
			end
		end

end#class
end#module
